#include <iostream>
#include <vector>
#include <algorithm>
#include <ctime>        // fuer time()
#include "PRINT.h"
using namespace std;

class Zufallszahl {
  public:
    unsigned long operator() (unsigned long max)
    {
        /* Zufallszahl aus Systemzeit zurueckliefern
         */
        return time((time_t*)0) % (long)max;
    }
};

int main()
{
    vector<int> menge;

    /* Elemente 1 bis 9 in die Menge einfuegen
     */
    for (int i=1; i<=9; i++) {
        menge.push_back(i);
    }

    PRINT ("vorher:        ", menge);

    /* Reihenfolge durcheinanderbringen
     */
    random_shuffle (menge.begin(), menge.end());

    PRINT ("durcheinander: ", menge);

    /* Menge sortieren
     */
    sort (menge.begin(), menge.end());

    PRINT ("sortiert:      ", menge);

    /* Menge mit unserem Zufallszahlen-Generator durcheinanderbringen
     *  - da Parameter lvalue ist, wird Hilfsvariable gebraucht
     */
    Zufallszahl z;
    random_shuffle (menge.begin()+1, menge.end()-1, z);

    PRINT ("unser Chaos:   ", menge);
}
