#include <iostream>
#include <deque>
#include <algorithm>
#include <functional>
using namespace std;

int main()
{
    deque<int> menge;

    /* Elemente 1 bis 9 in die Menge einfuegen
     */
    for (int i=1; i<=9; i++) {
        menge.push_back(i);
    }

    /* erste Folge von vier Elementen mit Wert 3 finden
     */
    deque<int>::iterator pos;
    pos = search_n (menge.begin(), menge.end(),
                    4, 3);

    /* gefunden ?
     */
    if (pos != menge.end()) {
        cout << "Vier 3en beginnen beim " << (pos - menge.begin()) + 1
             << ". Element" << endl;
    }
    else {
        cout << "Keine vier 3en gefunden" << endl;
    }

    /* erste Folge von vier Elementen mit Wert groesser als 3 finden
     */
    pos = search_n (menge.begin(), menge.end(),
                    4, 3, greater<int>());

    /* gefunden ?
     */
    if (pos != menge.end()) {
        cout << "Folge von vier Werten>3: ";
        copy (pos, pos+4,
              ostream_iterator<int>(cout," "));
        cout << endl;
    }
    else {
        cout << "Folge von vier Werten>3 nicht gefunden" << endl;
    }
}
