#include <iostream>
#include <deque>
#include <string>
#include <algorithm>
using namespace std;

int main()
{
    // leere String-Deque anlegen
    deque<string> menge;

    // verschiedene Werte einfuegen
    menge.assign (3, "String");
    menge.push_back ("letzter String");
    menge.push_front ("erster String");

    // Elemente durch Newlines getrennt ausgeben
    copy (menge.begin(), menge.end(),
          ostream_iterator<string>(cout,"\n"));
    cout << endl;

    // erstes und letztes Element loeschen
    menge.pop_front();
    menge.pop_back();

    // ab dem zweiten Element "noch ein " einfuegen
    for (int i=1; i<menge.size(); i++) {
        menge[i] = "noch ein " + menge[i];
    }

    // Groesse auf 4 Elemente aendern
    menge.resize (4, "String durch Vergroesserung");

    // Element durch Newlines getrennt ausgeben
    copy (menge.begin(), menge.end(),
          ostream_iterator<string>(cout,"\n"));
}
