#include <iostream>
#include <map>
#include <string>
using namespace std;

int main()
{
    /* Map / Dictionary / assoziatives Array
     * fuer String-Schluessel und Float-Wert
     * als Typ definieren
     */
    typedef map<string,float> StringFloatMap;

    /* eine leere Map anlegen
     */
    StringFloatMap aktien;

    /* einige Elemente einzeln einfuegen
     */
    aktien["BASF"] = 369.50;
    aktien["VW"] = 413.50;
    aktien["Daimler"] = 819.00;
    aktien["BMW"] = 834.00;
    aktien["Siemens"] = 842.20;

    /* alle Elemente ausgeben
     */
    StringFloatMap::iterator pos;
    for (pos = aktien.begin(); pos != aktien.end(); ++pos) {
        cout << "Aktie: " << pos->first << "\t"
             << "Kurs: "  << pos->second << endl;
    }
    cout << endl;

    /* OH: alle Aktien verdoppeln ihren Wert
     */
    for (pos = aktien.begin(); pos != aktien.end(); ++pos) {
        pos->second *= 2;
    }

    /* alle Elemente erneut ausgeben
     */
    for (pos = aktien.begin(); pos != aktien.end(); ++pos) {
        cout << "Aktie: " << pos->first << "\t"
             << "Kurs: "  << pos->second << endl;
    }
    cout << endl;

    /* Schluessel "VW" in "Volkswagen" umbenennen
     *  - geht nur durch Loeschen des alten und
     *    Einfuegen eines neuen Elements
     */
    aktien["Volkswagen"] = aktien["VW"];
    aktien.erase("VW");

    /* alle Elemente erneut ausgeben
     */
    for (pos = aktien.begin(); pos != aktien.end(); ++pos) {
        cout << "Aktie: " << pos->first << "\t"
             << "Kurs: "  << pos->second << endl;
    }
}
