template <class charT, class traits>
basic_ostream<charT,traits>&
operator << (basic_ostream<charT,traits>& strm, const Bruch& b)
{
    /* String-Stream
     * - mit gleichem Format
     * - ohne spezielle Feldbreite
     */
    basic_ostringstream<charT,traits> s;
    s.copyfmt(strm);
    s.width(0);

    // String-Stream fuellen
    s << b.zaehler() << '/' << b.nenner();

    // String-Stream ausgeben
    strm << s.str();

    return strm;
}
