// Header-Datei fuer Datei-I/O
#include <fstream>
using namespace std;

void gibDateiZweimalAus (const char* dateiname)
{
    char c;

    // Datei oeffnen
    ifstream datei (dateiname);

    // Inhalt einmal ausgeben
    while (datei.get(c)) {
        cout.put(c);
    }

    // Dateianfang erneut aufsuchen
    datei.seekg (0);

    // FAIL/EOF-Flags zuruecksetzen
    datei.clear();

    // Inhalt erneut ausgeben
    while (datei.get(c)) {
        cout.put(c);
    }
}

int main (int argc, char* argv[])
{
    // alle als Parameter uebergebenen Dateien zweimal ausgeben
    for (int i=1; i<argc; i++) {
        gibDateiZweimalAus (argv[i]);
    }
}
