#include <iostream>
#include <list>
#include <algorithm>
#include <numeric>
using namespace std;

int main()
{
    list<int> menge;

    /* Elemente 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge.push_back(i);
    }

    /* Mengen ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Summe aller Produkte
     *  0 + 1*1 + 2*2 + 3*3 + 4*4 + 5*5 + 6*6
     */
    cout << "inneres Produkt: "
         << inner_product (menge.begin(), menge.end(), 
                           menge.begin(), 0)
         << endl;

    /* Summe der Produkte aus 1*6 bis 6*1
     *  0 + 1*6 + 2*5 + 3*4 + 4*3 + 5*2 + 6*1
     */
    cout << "inneres Reverse-Produkt: "
         << inner_product (menge.begin(), menge.end(), 
                           menge.rbegin(), 0)
         << endl;

    /* Summen aufsummieren
     *  0 + 1+1 + 2+2 + 3+3 + 4+4 + 5+5 + 6+6
     */
    cout << "Summen: "
         << inner_product (menge.begin(), menge.end(), 
                           menge.begin(), 0,
                           plus<int>(), plus<int>())
         << endl;

    /* Produkt aller Summen
     *  1 * 1+1 * 2+2 * 3+3 * 4+4 * 5+5 * 6+6
     */
    cout << "Summe der Produkte: "
         << inner_product (menge.begin(), menge.end(), 
                           menge.begin(), 1,
                           multiplies<int>(), plus<int>())
         << endl;
}
