#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

bool pruefGerade (int elem, bool gerade)
{
    if (gerade) {
        return elem % 2 == 0;
    }
    else {
        return elem % 2 == 1;
    }
}

int main()
{
    vector<int> menge;

    /* Elemente 1 bis 9 in die erste Menge einfuegen
     */
    for (int i=1; i<=9; i++) {
        menge.push_back(i);
    }

    /* Elemente ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Element-Folgen "gerade ungerade gerade" suchen
     */
    bool pruefdaten[3] = { true, false, true };

    /* erste Folge suchen
     */
    vector<int>::iterator pos;
    pos = search (menge.begin(), menge.end(),
                  pruefdaten, pruefdaten+3, pruefGerade);

    /* gefunden ?
     */
    if (pos != menge.end()) {
        cout << "Folge \"gerade ungerade gerade\": ";
        copy (pos, pos+3, ostream_iterator<int>(cout," "));
        cout << endl;
    }
    else {
        cout << "Folge \"gerade ungerade gerade\" nicht gefunden" << endl;
    }

    /* in einer Schleife weitere Folgen suchen
     */
    while (pos != menge.end()) {
        pos = search (++pos, menge.end(),
                      pruefdaten, pruefdaten+3, pruefGerade);
    
        /* falls gefunden, ausgeben
         */
        if (pos != menge.end()) {
            cout << "Folge \"gerade ungerade gerade\": ";
            copy (pos, pos+3, ostream_iterator<int>(cout," "));
            cout << endl;
        }
    }
}
