#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include "PRINT.h"
using namespace std;

int main()
{
    vector<int> menge1;
    deque<int> menge2;

    /* Elemente 1 bis 9 bzw. 10 bis 19 in die Mengen einfuegen
     */
    for (int i=1; i<=9; i++) {
        menge1.push_back(i);
        menge2.push_back(i+10);
    }

    PRINT ("menge1: ", menge1);
    PRINT ("menge2: ", menge2);

    /* ersten vier Elemente der beiden Mengen vertauschen
     */
    swap_ranges (menge1.begin(), menge1.begin()+4,
                 menge2.begin());

    PRINT ("menge1: ", menge1);
    PRINT ("menge2: ", menge2);

    /* in der zweiten Menge ersten drei mit letzten drei
     * Elementen vertauschen
     */
    swap_ranges (menge2.begin(), menge2.begin()+3,
                 menge2.rbegin());

    PRINT ("menge2: ", menge2);
}
